// QDN.h: interface for the QRDNComp class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QDN_H__14DA5663_AFF4_11D2_89E9_C7DD96AE151A__INCLUDED_)
#define AFX_QDN_H__14DA5663_AFF4_11D2_89E9_C7DD96AE151A__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "stdafx.h"
#include "QAttr.h"
#include "Oidtable.h"

// Forward references
class QDSManager;

class AFX_EXT_CLASS QRDNAttr
{
public:
	QRDNAttr( QAttrT *attrt, char *ldap_val_ptr, unsigned long len );
	virtual ~QRDNAttr();

public:
  QAttrT *Type() { return attrt ; } ;
  QSyntax *Syntax() { return syntax ; } ;
  QValue *Value() { return rdn_val; } ;
  BOOL operator==( QRDNAttr &ra );

public:
  void Print( CString &str );

private:
  QAttrT *attrt;
  QValue *rdn_val;
  QSyntax *syntax;
};

template AFX_EXT_CLASS PtrList<QRDNAttr>;

class AFX_EXT_CLASS QRDN
{
public:
  QRDN( Oidtable *table, const CString &rdn );
	QRDN();
  ~QRDN();

public:
  BOOL GetRDNString( CString &str );
	BOOL GetFriendlyRDNString( CString &str );
	POSITION GetHeadRDNAttr()
		{
			return rdn_value_list.GetHeadPosition();
		}

	QRDNAttr *GetNextRDNAttr( POSITION &pos )
		{
			return rdn_value_list.GetNext( pos );
		}

public:
	QRDN &operator=( QRDN &r );
  BOOL operator==( QRDN &r );

protected:
  PtrList<QRDNAttr> rdn_value_list;
};

template AFX_EXT_CLASS PtrList<QRDN>;

class AFX_EXT_CLASS QDN
{
public:
  QDN();
  QDN( QDSManager *ds, long conn_id, CString &dn );
  ~QDN();

public:
  void UnsetDN();
  BOOL SetDN( QDSManager *ds_arg, long conn_id, CString &dn_str );
  BOOL GetDN( CString &str );
	BOOL GetFriendlyDN( CString &str );
  UINT GetRDNCount() { return rdn_list.GetCount() ; } ;
	BOOL GetRDN( QRDN &rdn );

public:
	POSITION GetHeadRDNPosition();
	QRDN *GetNextRDN( POSITION &rPos );

public:
  BOOL operator==( QDN &dn );
  QDN &operator=( QDN &dn );

public:
	QDSManager *DS();
	long GetConnID();
  Oidtable *Table();

private:
	BOOL is_set;
  QDSManager *ds;
	long conn_id;
  PtrList<QRDN> rdn_list;
};

template AFX_EXT_CLASS PtrList<QDN>;

#endif // !defined(AFX_QDN_H__14DA5663_AFF4_11D2_89E9_C7DD96AE151A__INCLUDED_)
